;=====<< IFUNC/IFUNCVAR >>===\
; Examples:
;	
; MyStruct struct
; 	pFunc1 IFUNC(x,y,z)
;	pFunc2 IFUNC(tx:real8,ty,vx:real8)
;	pFunc3 IFUNC(:DWORD,:DWORD,:QWORD)
; MyStruct ends
;
;
; SomeProc proc
;	local pFunc4:IFUNCVAR(x,y,z)
;	local pFunc5:IFUNCVAR(arg1:byte,arg2:byte)
;	local obj1:MyStruct
;	...
;	invoke pFunc4,1,2,3	
;	invoke obj1.pFunc1,7,8,9
;	lea ecx,obj1
;	invoke [ecx].MyStruct.pFunc1,7,8,9
;	ret
; SomeProc endp
;

@IFUNC_PROTO0 typedef proto
@IFUNC_PROTO1 typedef proto :DWORD
@IFUNC_PROTO2 typedef proto :DWORD,:DWORD
@IFUNC_PROTO3 typedef proto :DWORD,:DWORD,:DWORD
@IFUNC_PROTO4 typedef proto :DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO5 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO6 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO7 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO8 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO9 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
@IFUNC_PROTO10 typedef proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

@IFUNC_PFUNC0 typedef ptr @IFUNC_PROTO0
@IFUNC_PFUNC1 typedef ptr @IFUNC_PROTO1
@IFUNC_PFUNC2 typedef ptr @IFUNC_PROTO2
@IFUNC_PFUNC3 typedef ptr @IFUNC_PROTO3
@IFUNC_PFUNC4 typedef ptr @IFUNC_PROTO4
@IFUNC_PFUNC5 typedef ptr @IFUNC_PROTO5
@IFUNC_PFUNC6 typedef ptr @IFUNC_PROTO6
@IFUNC_PFUNC7 typedef ptr @IFUNC_PROTO7
@IFUNC_PFUNC8 typedef ptr @IFUNC_PROTO8
@IFUNC_PFUNC9 typedef ptr @IFUNC_PROTO9
@IFUNC_PFUNC10 typedef ptr @IFUNC_PROTO10

IFUNC macro args:VARARG
	local ArgCount,arg1,IsSpecial,intHasColon,intNumColons
	local strTypeArg
	
	
	ifndef @IFUNC_NumSpecialProtos
		@IFUNC_NumSpecialProtos = 0
	endif
	
	@IFUNC_NumSpecialProtos = @IFUNC_NumSpecialProtos + 1
	
	IsSpecial = 0
	ArgCount = 0
	intNumColons = 0
	
	for arg1,<args>
		ArgCount = ArgCount + 1
		intHasColon INSTR <arg1>,<:>
		if intHasColon
			intNumColons = intNumColons + 1
			strTypeArg SUBSTR <arg1>,intHasColon+1
			ifdif strTypeArg,<DWORD>
				ifdif strTypeArg,<real4>
					IsSpecial=1
				endif
			endif
		endif
	endm
	
	
	if IsSpecial
		if intNumColons eq ArgCount
			@CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos) typedef proto args
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) ?>
		else
			strTypeArg CATSTR <@IFUNC_$SP>,%@IFUNC_NumSpecialProtos,< typedef proto >
			for arg1,<args>
				ArgCount = ArgCount - 1
				intHasColon INSTR <arg1>,<:>
				if intHasColon
					strTypeArg CATSTR strTypeArg,<arg1>
				else
					strTypeArg CATSTR strTypeArg,<:DWORD>
				endif
				if ArgCount
					strTypeArg CATSTR strTypeArg,<,>
				endif
			endm
			strTypeArg
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) ?>		
		endif
	else
		exitm <@CatStr(<@IFUNC_PFUNC>,%ArgCount) ?>
		
	endif
	
endm


IFUNCVAR macro args:VARARG
	local ArgCount,arg1,IsSpecial,intHasColon,intNumColons
	local strTypeArg
	
	
	ifndef @IFUNC_NumSpecialProtos
		@IFUNC_NumSpecialProtos = 0
	endif
	
	@IFUNC_NumSpecialProtos = @IFUNC_NumSpecialProtos + 1
	
	IsSpecial = 0
	ArgCount = 0
	intNumColons = 0
	
	for arg1,<args>
		ArgCount = ArgCount + 1
		intHasColon INSTR <arg1>,<:>
		if intHasColon
			intNumColons = intNumColons + 1
			strTypeArg SUBSTR <arg1>,intHasColon+1
			ifdif strTypeArg,<DWORD>
				ifdif strTypeArg,<real4>
					IsSpecial=1
				endif
			endif
		endif
	endm
	
	
	if IsSpecial
		if intNumColons eq ArgCount
			@CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos) typedef proto args
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos)>
		else
			strTypeArg CATSTR <@IFUNC_$SP>,%@IFUNC_NumSpecialProtos,< typedef proto >
			for arg1,<args>
				ArgCount = ArgCount - 1
				intHasColon INSTR <arg1>,<:>
				if intHasColon
					strTypeArg CATSTR strTypeArg,<arg1>
				else
					strTypeArg CATSTR strTypeArg,<:DWORD>
				endif
				if ArgCount
					strTypeArg CATSTR strTypeArg,<,>
				endif
			endm
			strTypeArg
			@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos) typedef ptr @CatStr(<@IFUNC_$SP>,%@IFUNC_NumSpecialProtos)
			exitm <@CatStr(<@IFUNC_$PSP>,%@IFUNC_NumSpecialProtos)>	
		endif
	else
		exitm <@CatStr(<@IFUNC_PFUNC>,%ArgCount)>
		
	endif
	
endm

;=======/
